if (SERVER) then
	AddCSLuaFile("shared.lua")
	SWEP.Weight				= 5
	SWEP.AutoSwitchTo		= false
	SWEP.AutoSwitchFrom		= false
	SWEP.HoldType			= "slam"
end

if (CLIENT) then
	SWEP.PrintName			= "#Cstrike_WPNHUD_C4"
	SWEP.DrawAmmo			= true
	SWEP.DrawCrosshair		= false
	--SWEP.ViewModelFOV		= 60
	SWEP.ViewModelFlip		= false
	SWEP.CSMuzzleFlashes	= false
	SWEP.Slot = 4
SWEP.Category                   = "Counter-Strike: Source"
SWEP.IconLetter			= "I"
        SWEP.SlotPos = 1

killicon.AddFont( "lee_cs_c4", "CSKillIcons", SWEP.IconLetter, Color( 255, 80, 0, 255 ) )
end



SWEP.Author		= ""
SWEP.Contact		= ""
SWEP.Purpose		= ""


SWEP.AdminSpawnable		= true
SWEP.Spawnable                  = true

SWEP.ViewModel			= "models/weapons/v_c4.mdl"
SWEP.WorldModel			= "models/weapons/w_c4.mdl"

SWEP.Primary.ClipSize		= -1
SWEP.Primary.DefaultClip	= -1
SWEP.Primary.Automatic		= false
SWEP.Primary.Ammo			= "grenade"

SWEP.Secondary.ClipSize		= -1
SWEP.Secondary.DefaultClip	= -1
SWEP.Secondary.Automatic	= false
SWEP.Secondary.Ammo			= "none"


util.PrecacheSound("ambient/explosions/explode_1.wav")
util.PrecacheSound("buttons/blip1.wav")
util.PrecacheSound("buttons/button14.wav")
util.PrecacheSound("weapons/c4/c4_plant.wav")
util.PrecacheSound("weapons/c4/c4_beep1.wav")
util.PrecacheSound("weapons/c4/c4_click.wav")
util.PrecacheSound("weapons/c4/c4_explode1.wav")
util.PrecacheSound("weapons/c4/c4_exp_deb2.wav")
util.PrecacheSound("radio/bombpl.wav")

SWEP.reloadtimer = 1
SWEP.chargetimer = 10
SWEP.chargecountdown = SWEP.chargetimer
SWEP.SetNextReload = 1
SWEP.StartSprite = 1
SWEP.DetonationMode = 1
SWEP.RemoteDetonation = 0
SWEP.ShowHud = 0
SWEP.DetModeString = "Timed Detonation"


function SWEP:Initialize()

	if ( SERVER ) then
		self:SetWeaponHoldType( self.HoldType )
	end

end

/*---------------------------------------------------------
	Checks the objects before any action is taken
	This is to make sure that the entities haven't been removed
---------------------------------------------------------*/


function SWEP:DrawWeaponSelection(x, y, wide, tall, alpha)
	draw.SimpleText(self.IconLetter, "CSSelectIcons", x + wide/2, y + tall*0.2, Color(4, 12, 255, 255), TEXT_ALIGN_CENTER)
	-- Draw a cs select icon


	draw.SimpleText(self.IconLetter, "CSSelectIcons", x + wide/2 + math.Rand(-2, 2), y + tall*0.2+ math.Rand(-9, 9), Color(255, 50, 10, math.Rand(10, 120)), TEXT_ALIGN_CENTER)
	-- Try to fool them into thinking they're playing a Tony Hawks game

	self:PrintWeaponInfo(x + wide + 20, y + tall*0.95, alpha)
	-- Print weapon information

	
end



/*---------------------------------------------------------
	Countdown/Explosion
---------------------------------------------------------*/
function SWEP:chargecountdownfunction(charge)

         if self.chargecountdown == 0 then

         self.ShowHud = 0

         local effectdata = EffectData()
         effectdata:SetOrigin( self.charge:GetPos() )
         util.Effect( "SPonge", effectdata )
         
	 
	 for _,effect in pairs(ExplosionEffectTable) do
	     effect:Fire("Explode","",0)
             effect:Fire("kill","",1) 
         end
	 
	 
	 self.explosion:Fire("Explode","",0)
         self.physexplosion:Fire("explode","",0)
         
         
         self.charge:Fire("kill","",0.1)
         self.explosion:Fire("kill","",1)
         self.physexplosion:Fire("kill","",1)
         self.bombsprite:Fire("kill","",0.1)
         

         
         self.chargecountdown = self.chargetimer
         self.charge:EmitSound("ambient/explosions/explode_1.wav")
         self.charge:SetColor(255,255,255,0)
         self.chargeactive = 0
         
         for k, v in pairs(player.GetAll()) do
         v:EmitSound("ambient/explosions/explode.wav")
         v:EmitSound("weapons/c4/c4_explode1.wav")
         v:EmitSound("weapons/c4/c4_exp_deb2.wav")
         end

         self.entsinradius = ents.FindInSphere(self.charge:GetPos(),500)
         self.entstoignite = {}

         if self.entsinradius != nil then

            for _,ent in pairs(self.entsinradius) do

                 local trace = {}
	         trace.start = self.charge:GetPos()
                 trace.endpos = ent:GetPos()
                 trace.filter = {self.charge, self.explosion, self.shakeeffect, self.physexplosion, self.bombsprite, ent}

	         local tr = util.TraceLine(trace)

                       if tr.HitWorld == false then
                          table.insert(self.entstoignite , ent )
                       end
            end

            for _,ent in pairs(self.entstoignite) do
                if ent:GetClass() == "player" or ent:GetClass() == "prop_physics" then
                   ent:Ignite(math.random(10,20),0)
                end
            end
         end


         firetable = {}

         for i = 1,20,1 do
             self.boomfire = ents.Create("env_fire")
             self.boomfire:SetOwner( self.Owner )
             
             table.insert(firetable,self.boomfire)
         end



         for _,EntFire in pairs(firetable) do
             local trace = {}
	     trace.start = self.charge:GetPos()
	     trace.endpos = self.charge:GetPos() + Vector(0,0,200)
	     trace.filter = self.charge
             
             local tr = util.TraceLine(trace)
             
             local trace2 = {}
	     trace2.start = tr.HitPos
	     trace2.endpos = self.charge:GetPos() + Vector(math.random(-350,350),math.random(-350,350),0)
	     trace2.filter = self.charge
             
             local tr2 = util.TraceLine(trace2)
             
             EntFire:SetKeyValue("health",tostring(math.random(10,20)))
             EntFire:SetKeyValue("firesize",tostring(math.random(30,120)))
             EntFire:SetKeyValue("fireattack","1")
             EntFire:SetKeyValue("damagescale","20")
             EntFire:SetKeyValue("spawnflags","128")
             EntFire:SetPos(tr2.HitPos)
             EntFire:Spawn()
             EntFire:Activate()
             EntFire:Fire("StartFire","",0)
         end

         self.shakeeffect = ents.Create("env_shake")
         self.shakeeffect:SetKeyValue("amplitude","16")
         self.shakeeffect:SetKeyValue("spawnflags","29")
         self.shakeeffect:SetKeyValue("frequency","200.0")
         self.shakeeffect:SetKeyValue("duration","5")
         self.shakeeffect:SetPos(self.charge:GetPos())
         self.shakeeffect:Fire("StartShake","",0)
         self.shakeeffect:Fire("Kill","",4)
         
         sparktable = {}
         for i = 1,12,1 do
         self.EntSpark = ents.Create("env_spark")
         table.insert(sparktable,self.EntSpark)
         end
         
         for _,Sparks in pairs(sparktable) do
             local trace = {}
	     trace.start = self.charge:GetPos() + Vector(0,0,200)
	     trace.endpos = self.charge:GetPos() + Vector(math.random(-350,350),math.random(-350,350),math.random(0,250))
             local tr = util.TraceLine(trace)
             
             Sparks:SetKeyValue("Magnitude",tostring(math.random(2,8)))
             Sparks:SetKeyValue("TrailLength",tostring(math.random(1,3)))
             Sparks:SetPos(tr.HitPos)
             Sparks:Spawn()
             Sparks:Fire("SparkOnce","",0)
             Sparks:Fire("kill","",2)

         end

         elseif self.charge:IsValid() then
         self.charge:EmitSound("weapons/c4/c4_beep1.wav")
         self.chargecountdown = self.chargecountdown - 1
         self.Owner:PrintMessage(4,self.chargecountdown)
         timer.Simple(1,self.chargecountdownfunction,self,self.charge) 
         end
end

function SWEP:SpriteToggle(bombsprite)
         if self.chargecountdown == 0 then return end
            self.bombsprite:Fire("ToggleSprite","",0)

            timer.Simple(0.5,self.SpriteToggle,self,self.bombsprite)
end


/*---------------------------------------------------------
	Reload
---------------------------------------------------------*/
function SWEP:Reload()
         if CLIENT then return end
            if self.DetonationMode == 2 then return end



         if self.reloadtimer == 1 and self.SetNextReload == 1 then
         self.chargetimer = 5
         self.Owner:PrintMessage(4,"Charge set to 5 seconds.")
         self.Owner:EmitSound("weapons/c4/c4_click.wav")
         timer.Simple(0.2,self.NextReload1,self)
         self.SetNextReload = 0
self.Weapon:SendWeaponAnim( ACT_VM_DRAW )
         end

         if self.reloadtimer == 2 and self.SetNextReload == 1 then
         self.chargetimer = 10
         self.Owner:PrintMessage(4,"Charge set to 10 seconds.")
         self.Owner:EmitSound("weapons/c4/c4_click.wav")
         timer.Simple(0.2,self.NextReload2,self)
         self.SetNextReload = 0
self.Weapon:SendWeaponAnim( ACT_VM_DRAW )
         end

         if self.reloadtimer == 3 and self.SetNextReload == 1 then
         self.chargetimer = 20
         self.Owner:PrintMessage(4,"Charge set to 20 seconds.")
         self.Owner:EmitSound("weapons/c4/c4_click.wav")
         timer.Simple(0.2,self.NextReload3,self)
         self.SetNextReload = 0
self.Weapon:SendWeaponAnim( ACT_VM_DRAW )
         end

         if self.reloadtimer == 4 and self.SetNextReload == 1 then
         self.chargetimer = 60
         self.Owner:PrintMessage(4,"Charge set to 60 seconds.")
         self.Owner:EmitSound("weapons/c4/c4_click.wav")
         timer.Simple(0.2,self.NextReload4,self)
         self.SetNextReload = 0
self.Weapon:SendWeaponAnim( ACT_VM_DRAW )

         else return end


end

function SWEP:NextReload1()
         self.SetNextReload = 1
         self.reloadtimer = 2
end

function SWEP:NextReload2()
         self.SetNextReload = 1
         self.reloadtimer = 3

end

function SWEP:NextReload3()
         self.SetNextReload = 1
         self.reloadtimer = 4
end

function SWEP:NextReload4()
         self.SetNextReload = 1
         self.reloadtimer = 1
end

/*---------------------------------------------------------
   Think
---------------------------------------------------------*/
function SWEP:Think()

end

/*---------------------------------------------------------
	plant bomb
---------------------------------------------------------*/
function SWEP:plantbomb()
 if CLIENT then return end

        local ang = self.Owner:GetAimVector()
	local spos = self.Owner:GetShootPos()

	local trace = {}
	trace.start = spos
	trace.endpos = spos + (ang * 100)
	trace.filter = self.Owner
	
	local tr = util.TraceLine(trace)
	local hitpos = tr.HitPos

        if self.RemoteDetonation == 0 and (tr.HitWorld or tr.HitNonWorld)then

           self.charge = ents.Create("prop_physics")
           self.charge:SetModel("models/weapons/w_c4_planted.mdl")
           self.charge:SetPos(hitpos + Vector(0,0,1))
           self.charge:SetKeyValue("spawnflags","1026")
           self.charge:Spawn()
           self:TakePrimaryAmmo(1)
	   /*self.charge:EnableMotion( false )*/
           


           self.charge:SetVelocity(self.Owner:GetForward() * 20)

           ExplosionEffectTable = {}
           for i = 1,5,1 do
               self.explosioneffect = ents.Create("env_ar2explosion")
               self.explosioneffect:SetPos(self.charge:GetPos() + Vector(0,0,5))
               self.explosioneffect:Spawn()
               self.explosioneffect:SetParent(self.charge)
               table.insert(ExplosionEffectTable,self.explosioneffect)
           end

           self.explosion = ents.Create("env_explosion")
           self.explosion:SetPos(self.charge:GetPos() + Vector(0,0,5))
           self.explosion:SetKeyValue("iMagnitude","800")
           self.explosion:SetKeyValue("spawnflags","868")
           self.explosion:Spawn()
           self.explosion:SetOwner( self.Owner )

           self.explosion:SetParent(self.charge)

           self.physexplosion = ents.Create("env_physexplosion")
           self.physexplosion:SetPos(self.charge:GetPos() + Vector(0,0,5))
           self.physexplosion:SetKeyValue("Magnitude","1000")
           self.physexplosion:SetKeyValue("radius","900")
           self.physexplosion:SetKeyValue("spawnflags","19")
           self.physexplosion:Spawn()
           self.physexplosion:SetOwner( self.Owner )
          
	  self.physexplosion:SetParent(self.charge)

           self.bombsprite = ents.Create("env_sprite")
           self.bombsprite:SetKeyValue("model","sprites/blueflare1.spr")
           self.bombsprite:SetKeyValue("scale","0.3")
           self.bombsprite:SetKeyValue("rendermode","3")
           self.bombsprite:SetKeyValue("rendercolor","255 0 0")
           self.bombsprite:SetPos(self.charge:GetPos() + Vector(0,0,10))
           self.bombsprite:SetParent(self.charge)
           self.bombsprite:Spawn()
           self.bombsprite:Fire("ShowSprite","",0)
           
	   self.bombsprite = ents.Create("env_sprite")
           self.bombsprite:SetKeyValue("model","sprites/blueflare1.spr")
           self.bombsprite:SetKeyValue("scale","0.3")
           self.bombsprite:SetKeyValue("rendermode","3")
           self.bombsprite:SetKeyValue("rendercolor","255 0 0")
           self.bombsprite:SetPos(self.charge:GetPos() + Vector(0,0,10))
           self.bombsprite:SetParent(self.charge)
           self.bombsprite:Spawn()
           self.bombsprite:Fire("ShowSprite","",0)
           
	   self.Owner:EmitSound("weapons/c4/c4_plant.wav")
           self.Owner:EmitSound("radio/bombpl.wav");
           self.Weapon:SendWeaponAnim( ACT_VM_DRAW )
self.Owner:SetAnimation( PLAYER_ATTACK1 )

           if self.DetonationMode == 1 then
              self.chargecountdown = self.chargetimer
              self.chargetimer2 = self.chargetimer
        
              self.Weapon:SetNextPrimaryFire(CurTime() + self.chargetimer2 + 2)
        
              timer.Simple(0,self.chargecountdownfunction,self,self.charge)
        
              timer.Simple(0.5,self.SpriteToggle,self,self.bombsprite)
              
              self.ShowHud = 1
           end
        
           if self.DetonationMode == 2 then
 
              self.RemoteDetonation = 1

           end


        elseif self.RemoteDetonation == 1 then
               self.chargecountdown = 0
               timer.Simple(0,self.chargecountdownfunction,self,self.charge)
    
               self.RemoteDetonation = 0
        end

end


/*---------------------------------------------------------
	PrimaryAttack
---------------------------------------------------------*/
function SWEP:PrimaryAttack()
self.Weapon:SendWeaponAnim(ACT_VM_PRIMARYATTACK)

if ( SERVER ) then

timer.Simple( 2.8 , function() self:plantbomb() end )

end
end

       

function PlayerExtinguish(ply)
         if ply:IsOnFire() then
         ply:Extinguish()
         else return end
end

hook.Add("PlayerSpawn","PlayerExtinguishfix",PlayerExtinguish)
/*---------------------------------------------------------
	SecondaryAttack
---------------------------------------------------------*/
function SWEP:SecondaryAttack()
        if CLIENT then return end
           if self.RemoteDetonation == 1 then return end
           
           if self.DetonationMode == 1 then
              self.DetonationMode = 2
              self.Owner:PrintMessage(4,"Detonation mode 2: Remote detonation")
           
           elseif self.DetonationMode == 2 then
              self.DetonationMode = 1
              self.Owner:PrintMessage(4,"Detonation mode 1: Timed detonation")
           end
           
           self.Owner:EmitSound("buttons/button14.wav")
           self.Weapon:SetNextSecondaryFire(CurTime() + 0.3)
end

/*---------------------------------------------------------
	Hud drawing functions Can't get this messy crap to work :)
---------------------------------------------------------
function SWEP:DrawHUD()
             //My code
             if self.DetonationMode == 1 then
                
                draw.SimpleText( "Timed Detonation" , "ScoreboardText" , 100, 50, Color(255,0,255,255),1,1)
             
             elseif self.DetonationMode == 2 then
                
                draw.SimpleText( "Remote Detonation" , "ScoreboardText" , 100, 50, Color(255,0,255,255),1,1)
             end
             
             draw.RoundedBox( 10, 30 , 30 , 200 , 30 , Color( 200,200,200,150 ))


             if self.ShowHud == 1 then
                local pos = self.charge:GetPos():ToScreen()
                draw.RoundedBox( 2, pos.x + 10 , pos.y , 130 , 130 , Color( 200,200,200,150 ))
                draw.SimpleText( tostring(self.chargecountdown) , "ScoreboardText" , 100, 50, Color(255,0,255,255),1,1)
             end
                //END of my code
                
                //Copy from another code
                if self.Owner:KeyDown( IN_ATTACK2 ) then
			draw.SimpleText( "::LAUNCHING GRENADE::", "Trebuchet24", surface.ScreenWidth() / 2.2 + 40, surface.ScreenHeight() / 14 - 34, Color( 255, 0, 0, 255 ), 0, 0 )
		end
		//END of copy from another code
end*/


function SWEP:Deploy()
	self.Weapon:SendWeaponAnim( ACT_VM_DRAW )
	self.Weapon:SetNextPrimaryFire(CurTime() + 1)
	return true;
end



        

